package nxm.sys.inc;

/** Defines a generic filter that will determine is an entry is to be accepted or rejected.

    @author Jeff Schoen
    @version $Id: Filter.java,v 1.4 2014/10/21 18:23:52 ntn Exp $
 */
public interface Filter {

  /** Tests an entry to see if it should be accepted or rejected.

      @param entry The entry to test.
      @return <code>true</code> if the entry meets the criteria (accept),
              <code>false</code> otherwise (reject).
   */
  boolean accept (Object entry);
}
