package nxm.sys.inc;

/** Numerical equivalent definitions of special Unicode characters. <br>
    <br>
    Use the <code>{@link UnicodeMap}.<span style="color:blue">NAME</span></code> syntax when accessing
    the definitions in this class.

    @see AsciiMap

    @author  J. Czechowski IV
    @version $Id: UnicodeMap.java,v 1.8 2014/10/21 19:01:12 ntn Exp $
    @since   NeXtMidas 1.9.5
 */
public interface UnicodeMap extends AsciiMap {
  ////// Official Unicode Names ////////////////////////////////////////////////////////////////////
  /** Unicode DEGREE SIGN.       */
  char DEGREE_SIGN       = '\u00B0';
  /** Unicode PLUS-MINUS SIGN.   */
  char PLUS_MINUS_SIGN   = '\u00B1';
  /** Unicode SUPERSCRIPT TWO.   */
  char SUPERSCRIPT_TWO   = '\u00B2';
  /** Unicode SUPERSCRIPT THREE. */
  char SUPERSCRIPT_THREE = '\u00B3';

  /** Unicode MICRO SIGN.        */
  char MICRO_SIGN        = '\u00B5';

  /** Unicode MIDDLE DOT.        */
  char MIDDLE_DOT        = '\u00B7';

  /** Unicode SUPERSCRIPT ONE.   */
  char SUPERSCRIPT_ONE   = '\u00B9';

  /** Unicode INFINITY.   */
  char INFINITY          = '\u221E';

  ////// Common Names //////////////////////////////////////////////////////////////////////////////

  /** The squared sign (same as {@link #SUPERSCRIPT_TWO}). */
  char SQUARED = SUPERSCRIPT_TWO;

  /** The cubed sign (same as {@link #SUPERSCRIPT_THREE}). */
  char CUBED = SUPERSCRIPT_THREE;
}
